Index: dnspython-1.12.0/dns/rdtypes/IN/IPSECKEY.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/IPSECKEY.py
+++ dnspython-1.12.0/dns/rdtypes/IN/IPSECKEY.py
@@ -13,14 +13,18 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
+from io import BytesIO
 import struct
+import base64
 
 import dns.exception
 import dns.inet
 import dns.name
+from dns._compat import xcmp
+
 
 class IPSECKEY(dns.rdata.Rdata):
+
     """IPSECKEY record
 
     @ivar precedence: the precedence for this key data
@@ -41,19 +45,20 @@ class IPSECKEY(dns.rdata.Rdata):
                  gateway, key):
         super(IPSECKEY, self).__init__(rdclass, rdtype)
         if gateway_type == 0:
-            if gateway != '.' and not gateway is None:
+            if gateway != '.' and gateway is not None:
                 raise SyntaxError('invalid gateway for gateway type 0')
             gateway = None
         elif gateway_type == 1:
             # check that it's OK
-            junk = dns.inet.inet_pton(dns.inet.AF_INET, gateway)
+            dns.inet.inet_pton(dns.inet.AF_INET, gateway)
         elif gateway_type == 2:
             # check that it's OK
-            junk = dns.inet.inet_pton(dns.inet.AF_INET6, gateway)
+            dns.inet.inet_pton(dns.inet.AF_INET6, gateway)
         elif gateway_type == 3:
             pass
         else:
-            raise SyntaxError('invalid IPSECKEY gateway type: %d' % gateway_type)
+            raise SyntaxError(
+                'invalid IPSECKEY gateway type: %d' % gateway_type)
         self.precedence = precedence
         self.gateway_type = gateway_type
         self.algorithm = algorithm
@@ -75,7 +80,8 @@ class IPSECKEY(dns.rdata.Rdata):
                                    self.algorithm, gateway,
                                    dns.rdata._base64ify(self.key))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         precedence = tok.get_uint8()
         gateway_type = tok.get_uint8()
         algorithm = tok.get_uint8()
@@ -90,15 +96,13 @@ class IPSECKEY(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        b64 = ''.join(chunks)
-        key = b64.decode('base64_codec')
+            chunks.append(t.value.encode())
+        b64 = b''.join(chunks)
+        key = base64.b64decode(b64)
         return cls(rdclass, rdtype, precedence, gateway_type, algorithm,
                    gateway, key)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         header = struct.pack("!BBB", self.precedence, self.gateway_type,
                              self.algorithm)
         file.write(header)
@@ -114,10 +118,11 @@ class IPSECKEY(dns.rdata.Rdata):
             raise ValueError('invalid gateway type')
         file.write(self.key)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         if rdlen < 3:
             raise dns.exception.FormError
-        header = struct.unpack('!BBB', wire[current : current + 3])
+        header = struct.unpack('!BBB', wire[current: current + 3])
         gateway_type = header[1]
         current += 3
         rdlen -= 3
@@ -125,12 +130,12 @@ class IPSECKEY(dns.rdata.Rdata):
             gateway = None
         elif gateway_type == 1:
             gateway = dns.inet.inet_ntop(dns.inet.AF_INET,
-                                         wire[current : current + 4])
+                                         wire[current: current + 4])
             current += 4
             rdlen -= 4
         elif gateway_type == 2:
             gateway = dns.inet.inet_ntop(dns.inet.AF_INET6,
-                                         wire[current : current + 16])
+                                         wire[current: current + 16])
             current += 16
             rdlen -= 16
         elif gateway_type == 3:
@@ -144,10 +149,8 @@ class IPSECKEY(dns.rdata.Rdata):
         return cls(rdclass, rdtype, header[0], gateway_type, header[2],
                    gateway, key)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f)
         wire1 = f.getvalue()
         f.seek(0)
@@ -156,4 +159,4 @@ class IPSECKEY(dns.rdata.Rdata):
         wire2 = f.getvalue()
         f.close()
 
-        return cmp(wire1, wire2)
+        return xcmp(wire1, wire2)
Index: dnspython-1.12.0/dns/rdtypes/IN/NAPTR.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/NAPTR.py
+++ dnspython-1.12.0/dns/rdtypes/IN/NAPTR.py
@@ -18,15 +18,25 @@ import struct
 import dns.exception
 import dns.name
 import dns.rdata
+from dns._compat import xrange, text_type
+from dns._compat import xcmp
+
 
 def _write_string(file, s):
     l = len(s)
     assert l < 256
-    byte = chr(l)
-    file.write(byte)
+    file.write(struct.pack('!B', l))
     file.write(s)
 
+
+def _sanitize(value):
+    if isinstance(value, text_type):
+        return value.encode()
+    return value
+
+
 class NAPTR(dns.rdata.Rdata):
+
     """NAPTR record
 
     @ivar order: order
@@ -49,11 +59,11 @@ class NAPTR(dns.rdata.Rdata):
     def __init__(self, rdclass, rdtype, order, preference, flags, service,
                  regexp, replacement):
         super(NAPTR, self).__init__(rdclass, rdtype)
+        self.flags = _sanitize(flags)
+        self.service = _sanitize(service)
+        self.regexp = _sanitize(regexp)
         self.order = order
         self.preference = preference
-        self.flags = flags
-        self.service = service
-        self.regexp = regexp
         self.replacement = replacement
 
     def to_text(self, origin=None, relativize=True, **kw):
@@ -63,9 +73,10 @@ class NAPTR(dns.rdata.Rdata):
                 dns.rdata._escapify(self.flags),
                 dns.rdata._escapify(self.service),
                 dns.rdata._escapify(self.regexp),
-                self.replacement)
+                replacement)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         order = tok.get_uint16()
         preference = tok.get_uint16()
         flags = tok.get_string()
@@ -77,9 +88,7 @@ class NAPTR(dns.rdata.Rdata):
         return cls(rdclass, rdtype, order, preference, flags, service,
                    regexp, replacement)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         two_ints = struct.pack("!HH", self.order, self.preference)
         file.write(two_ints)
         _write_string(file, self.flags)
@@ -87,18 +96,19 @@ class NAPTR(dns.rdata.Rdata):
         _write_string(file, self.regexp)
         self.replacement.to_wire(file, compress, origin)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        (order, preference) = struct.unpack('!HH', wire[current : current + 4])
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
+        (order, preference) = struct.unpack('!HH', wire[current: current + 4])
         current += 4
         rdlen -= 4
         strings = []
         for i in xrange(3):
-            l = ord(wire[current])
+            l = wire[current]
             current += 1
             rdlen -= 1
             if l > rdlen or rdlen < 0:
                 raise dns.exception.FormError
-            s = wire[current : current + l].unwrap()
+            s = wire[current: current + l].unwrap()
             current += l
             rdlen -= l
             strings.append(s)
@@ -106,27 +116,25 @@ class NAPTR(dns.rdata.Rdata):
                                                   current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             replacement = replacement.relativize(origin)
         return cls(rdclass, rdtype, order, preference, strings[0], strings[1],
                    strings[2], replacement)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.replacement = self.replacement.choose_relativity(origin,
                                                               relativize)
 
     def _cmp(self, other):
         sp = struct.pack("!HH", self.order, self.preference)
         op = struct.pack("!HH", other.order, other.preference)
-        v = cmp(sp, op)
+        v = xcmp(sp, op)
         if v == 0:
-            v = cmp(self.flags, other.flags)
+            v = xcmp(self.flags, other.flags)
             if v == 0:
-                v = cmp(self.service, other.service)
+                v = xcmp(self.service, other.service)
                 if v == 0:
-                    v = cmp(self.regexp, other.regexp)
+                    v = xcmp(self.regexp, other.regexp)
                     if v == 0:
-                        v = cmp(self.replacement, other.replacement)
+                        v = xcmp(self.replacement, other.replacement)
         return v
Index: dnspython-1.12.0/dns/rdtypes/IN/NSAP.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/NSAP.py
+++ dnspython-1.12.0/dns/rdtypes/IN/NSAP.py
@@ -13,11 +13,16 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import binascii
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
 
+from dns._compat import xcmp
+
 class NSAP(dns.rdata.Rdata):
+
     """NSAP record.
 
     @ivar address: a NASP
@@ -31,8 +36,9 @@ class NSAP(dns.rdata.Rdata):
         self.address = address
 
     def to_text(self, origin=None, relativize=True, **kw):
-        return "0x%s" % self.address.encode('hex_codec')
+        return "0x%s" % binascii.hexlify(self.address).decode()
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         address = tok.get_string()
         t = tok.get_eol()
@@ -41,19 +47,16 @@ class NSAP(dns.rdata.Rdata):
         address = address[2:].replace('.', '')
         if len(address) % 2 != 0:
             raise dns.exception.SyntaxError('hexstring has odd length')
-        address = address.decode('hex_codec')
+        address = binascii.unhexlify(address.encode())
         return cls(rdclass, rdtype, address)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(self.address)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         address = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, address)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        return cmp(self.address, other.address)
+        return xcmp(self.address, other.address)
Index: dnspython-1.12.0/dns/rdtypes/IN/PX.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/PX.py
+++ dnspython-1.12.0/dns/rdtypes/IN/PX.py
@@ -18,8 +18,11 @@ import struct
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class PX(dns.rdata.Rdata):
+
     """PX record.
 
     @ivar preference: the preference value
@@ -43,7 +46,8 @@ class PX(dns.rdata.Rdata):
         mapx400 = self.mapx400.choose_relativity(origin, relativize)
         return '%d %s %s' % (self.preference, map822, mapx400)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         preference = tok.get_uint16()
         map822 = tok.get_name()
         map822 = map822.choose_relativity(origin, relativize)
@@ -52,46 +56,43 @@ class PX(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, preference, map822, mapx400)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         pref = struct.pack("!H", self.preference)
         file.write(pref)
         self.map822.to_wire(file, None, origin)
         self.mapx400.to_wire(file, None, origin)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        (preference, ) = struct.unpack('!H', wire[current : current + 2])
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
+        (preference, ) = struct.unpack('!H', wire[current: current + 2])
         current += 2
         rdlen -= 2
         (map822, cused) = dns.name.from_wire(wire[: current + rdlen],
-                                               current)
+                                             current)
         if cused > rdlen:
             raise dns.exception.FormError
         current += cused
         rdlen -= cused
-        if not origin is None:
+        if origin is not None:
             map822 = map822.relativize(origin)
         (mapx400, cused) = dns.name.from_wire(wire[: current + rdlen],
                                               current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             mapx400 = mapx400.relativize(origin)
         return cls(rdclass, rdtype, preference, map822, mapx400)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.map822 = self.map822.choose_relativity(origin, relativize)
         self.mapx400 = self.mapx400.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
         sp = struct.pack("!H", self.preference)
         op = struct.pack("!H", other.preference)
-        v = cmp(sp, op)
+        v = xcmp(sp, op)
         if v == 0:
-            v = cmp(self.map822, other.map822)
+            v = xcmp(self.map822, other.map822)
             if v == 0:
-                v = cmp(self.mapx400, other.mapx400)
+                v = xcmp(self.mapx400, other.mapx400)
         return v
Index: dnspython-1.12.0/dns/rdtypes/IN/SRV.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/SRV.py
+++ dnspython-1.12.0/dns/rdtypes/IN/SRV.py
@@ -18,8 +18,11 @@ import struct
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class SRV(dns.rdata.Rdata):
+
     """SRV record
 
     @ivar priority: the priority
@@ -46,7 +49,8 @@ class SRV(dns.rdata.Rdata):
         return '%d %d %d %s' % (self.priority, self.weight, self.port,
                                 target)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         priority = tok.get_uint16()
         weight = tok.get_uint16()
         port = tok.get_uint16()
@@ -55,35 +59,32 @@ class SRV(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, priority, weight, port, target)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         three_ints = struct.pack("!HHH", self.priority, self.weight, self.port)
         file.write(three_ints)
         self.target.to_wire(file, compress, origin)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (priority, weight, port) = struct.unpack('!HHH',
-                                                 wire[current : current + 6])
+                                                 wire[current: current + 6])
         current += 6
         rdlen -= 6
         (target, cused) = dns.name.from_wire(wire[: current + rdlen],
                                              current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             target = target.relativize(origin)
         return cls(rdclass, rdtype, priority, weight, port, target)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.target = self.target.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
         sp = struct.pack("!HHH", self.priority, self.weight, self.port)
         op = struct.pack("!HHH", other.priority, other.weight, other.port)
-        v = cmp(sp, op)
+        v = xcmp(sp, op)
         if v == 0:
-            v = cmp(self.target, other.target)
+            v = xcmp(self.target, other.target)
         return v
Index: dnspython-1.12.0/dns/rdtypes/IN/WKS.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/IN/WKS.py
+++ dnspython-1.12.0/dns/rdtypes/IN/WKS.py
@@ -18,11 +18,15 @@ import struct
 
 import dns.ipv4
 import dns.rdata
+from dns._compat import xrange
+from dns._compat import xcmp
 
 _proto_tcp = socket.getprotobyname('tcp')
 _proto_udp = socket.getprotobyname('udp')
 
+
 class WKS(dns.rdata.Rdata):
+
     """WKS record
 
     @ivar address: the address
@@ -39,26 +43,30 @@ class WKS(dns.rdata.Rdata):
         super(WKS, self).__init__(rdclass, rdtype)
         self.address = address
         self.protocol = protocol
-        self.bitmap = bitmap
+        if not isinstance(bitmap, bytearray):
+            self.bitmap = bytearray(bitmap)
+        else:
+            self.bitmap = bitmap
 
     def to_text(self, origin=None, relativize=True, **kw):
         bits = []
         for i in xrange(0, len(self.bitmap)):
-            byte = ord(self.bitmap[i])
+            byte = self.bitmap[i]
             for j in xrange(0, 8):
                 if byte & (0x80 >> j):
                     bits.append(str(i * 8 + j))
         text = ' '.join(bits)
         return '%s %d %s' % (self.address, self.protocol, text)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         address = tok.get_string()
         protocol = tok.get_string()
         if protocol.isdigit():
             protocol = int(protocol)
         else:
             protocol = socket.getprotobyname(protocol)
-        bitmap = []
+        bitmap = bytearray()
         while 1:
             token = tok.get().unescape()
             if token.is_eol_or_eof():
@@ -77,19 +85,18 @@ class WKS(dns.rdata.Rdata):
             l = len(bitmap)
             if l < i + 1:
                 for j in xrange(l, i + 1):
-                    bitmap.append('\x00')
-            bitmap[i] = chr(ord(bitmap[i]) | (0x80 >> (serv % 8)))
+                    bitmap.append(0)
+            bitmap[i] = bitmap[i] | (0x80 >> (serv % 8))
         bitmap = dns.rdata._truncate_bitmap(bitmap)
         return cls(rdclass, rdtype, address, protocol, bitmap)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(dns.ipv4.inet_aton(self.address))
         protocol = struct.pack('!B', self.protocol)
         file.write(protocol)
         file.write(self.bitmap)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         address = dns.ipv4.inet_ntoa(wire[current : current + 4])
         protocol, = struct.unpack('!B', wire[current + 4 : current + 5])
@@ -98,16 +105,14 @@ class WKS(dns.rdata.Rdata):
         bitmap = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, address, protocol, bitmap)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         sa = dns.ipv4.inet_aton(self.address)
         oa = dns.ipv4.inet_aton(other.address)
-        v = cmp(sa, oa)
+        v = xcmp(sa, oa)
         if v == 0:
             sp = struct.pack('!B', self.protocol)
             op = struct.pack('!B', other.protocol)
-            v = cmp(sp, op)
+            v = xcmp(sp, op)
             if v == 0:
-                v = cmp(self.bitmap, other.bitmap)
+                v = xcmp(self.bitmap, other.bitmap)
         return v
Index: dnspython-1.12.0/dns/rdtypes/dsbase.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/dsbase.py
+++ dnspython-1.12.0/dns/rdtypes/dsbase.py
@@ -14,11 +14,15 @@
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 import struct
+import binascii
 
 import dns.rdata
 import dns.rdatatype
+from dns._compat import xcmp
+
 
 class DSBase(dns.rdata.Rdata):
+
     """Base class for rdata that is like a DS record
 
     @ivar key_tag: the key tag
@@ -47,7 +51,8 @@ class DSBase(dns.rdata.Rdata):
                                 dns.rdata._hexify(self.digest,
                                                   chunksize=128))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         key_tag = tok.get_uint16()
         algorithm = tok.get_uint8()
         digest_type = tok.get_uint8()
@@ -58,20 +63,19 @@ class DSBase(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        digest = ''.join(chunks)
-        digest = digest.decode('hex_codec')
+            chunks.append(t.value.encode())
+        digest = b''.join(chunks)
+        digest = binascii.unhexlify(digest)
         return cls(rdclass, rdtype, key_tag, algorithm, digest_type,
                    digest)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         header = struct.pack("!HBB", self.key_tag, self.algorithm,
                              self.digest_type)
         file.write(header)
         file.write(self.digest)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         header = struct.unpack("!HBB", wire[current : current + 4])
         current += 4
@@ -79,14 +83,12 @@ class DSBase(dns.rdata.Rdata):
         digest = wire[current : current + rdlen].unwrap()
         return cls(rdclass, rdtype, header[0], header[1], header[2], digest)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         hs = struct.pack("!HBB", self.key_tag, self.algorithm,
                          self.digest_type)
         ho = struct.pack("!HBB", other.key_tag, other.algorithm,
                          other.digest_type)
-        v = cmp(hs, ho)
+        v = xcmp(hs, ho)
         if v == 0:
-            v = cmp(self.digest, other.digest)
+            v = xcmp(self.digest, other.digest)
         return v
Index: dnspython-1.12.0/dns/rdtypes/mxbase.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/mxbase.py
+++ dnspython-1.12.0/dns/rdtypes/mxbase.py
@@ -15,14 +15,17 @@
 
 """MX-like base classes."""
 
-import cStringIO
+from io import BytesIO
 import struct
 
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class MXBase(dns.rdata.Rdata):
+
     """Base class for rdata that is like an MX record.
 
     @ivar preference: the preference value
@@ -41,6 +44,7 @@ class MXBase(dns.rdata.Rdata):
         exchange = self.exchange.choose_relativity(origin, relativize)
         return '%d %s' % (self.preference, exchange)
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         preference = tok.get_uint16()
         exchange = tok.get_name()
@@ -48,8 +52,6 @@ class MXBase(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, preference, exchange)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         pref = struct.pack("!H", self.preference)
         file.write(pref)
@@ -59,6 +61,7 @@ class MXBase(dns.rdata.Rdata):
         return struct.pack("!H", self.preference) + \
             self.exchange.to_digestable(origin)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         (preference, ) = struct.unpack('!H', wire[current : current + 2])
         current += 2
@@ -67,21 +70,19 @@ class MXBase(dns.rdata.Rdata):
                                                current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             exchange = exchange.relativize(origin)
         return cls(rdclass, rdtype, preference, exchange)
 
-    from_wire = classmethod(from_wire)
-
     def choose_relativity(self, origin = None, relativize = True):
         self.exchange = self.exchange.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
         sp = struct.pack("!H", self.preference)
         op = struct.pack("!H", other.preference)
-        v = cmp(sp, op)
+        v = xcmp(sp, op)
         if v == 0:
-            v = cmp(self.exchange, other.exchange)
+            v = xcmp(self.exchange, other.exchange)
         return v
 
 class UncompressedMX(MXBase):
@@ -93,7 +94,7 @@ class UncompressedMX(MXBase):
         super(UncompressedMX, self).to_wire(file, None, origin)
 
     def to_digestable(self, origin = None):
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f, None, origin)
         return f.getvalue()
 
Index: dnspython-1.12.0/dns/rdtypes/nsbase.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/nsbase.py
+++ dnspython-1.12.0/dns/rdtypes/nsbase.py
@@ -15,13 +15,16 @@
 
 """NS-like base classes."""
 
-import cStringIO
+from io import BytesIO
 
 import dns.exception
 import dns.rdata
 import dns.name
+from dns._compat import xcmp
+
 
 class NSBase(dns.rdata.Rdata):
+
     """Base class for rdata that is like an NS record.
 
     @ivar target: the target name of the rdata
@@ -37,36 +40,34 @@ class NSBase(dns.rdata.Rdata):
         target = self.target.choose_relativity(origin, relativize)
         return str(target)
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         target = tok.get_name()
         target = target.choose_relativity(origin, relativize)
         tok.get_eol()
         return cls(rdclass, rdtype, target)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         self.target.to_wire(file, compress, origin)
 
     def to_digestable(self, origin = None):
         return self.target.to_digestable(origin)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         (target, cused) = dns.name.from_wire(wire[: current + rdlen],
                                              current)
         if cused != rdlen:
             raise dns.exception.FormError
-        if not origin is None:
+        if origin is not None:
             target = target.relativize(origin)
         return cls(rdclass, rdtype, target)
 
-    from_wire = classmethod(from_wire)
-
     def choose_relativity(self, origin = None, relativize = True):
         self.target = self.target.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
-        return cmp(self.target, other.target)
+        return xcmp(self.target, other.target)
 
 class UncompressedNS(NSBase):
     """Base class for rdata that is like an NS record, but whose name
@@ -76,7 +77,7 @@ class UncompressedNS(NSBase):
     def to_wire(self, file, compress = None, origin = None):
         super(UncompressedNS, self).to_wire(file, None, origin)
 
-    def to_digestable(self, origin = None):
-        f = cStringIO.StringIO()
+    def to_digestable(self, origin=None):
+        f = BytesIO()
         self.to_wire(f, None, origin)
         return f.getvalue()
Index: dnspython-1.12.0/dns/rdtypes/txtbase.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/txtbase.py
+++ dnspython-1.12.0/dns/rdtypes/txtbase.py
@@ -15,11 +15,17 @@
 
 """TXT-like base class."""
 
+import struct
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
+from dns._compat import binary_type, text_type
+from dns._compat import xcmp
+
 
 class TXTBase(dns.rdata.Rdata):
+
     """Base class for rdata that is like a TXT record
 
     @ivar strings: the text strings
@@ -30,8 +36,8 @@ class TXTBase(dns.rdata.Rdata):
 
     def __init__(self, rdclass, rdtype, strings):
         super(TXTBase, self).__init__(rdclass, rdtype)
-        if isinstance(strings, str):
-            strings = [ strings ]
+        if isinstance(strings, text_type):
+            strings = [strings]
         self.strings = strings[:]
 
     def to_text(self, origin=None, relativize=True, **kw):
@@ -42,7 +48,8 @@ class TXTBase(dns.rdata.Rdata):
             prefix = ' '
         return txt
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         strings = []
         while 1:
             token = tok.get().unescape()
@@ -52,25 +59,27 @@ class TXTBase(dns.rdata.Rdata):
                 raise dns.exception.SyntaxError("expected a string")
             if len(token.value) > 255:
                 raise dns.exception.SyntaxError("string too long")
-            strings.append(token.value)
+            value = token.value
+            if isinstance(value, binary_type):
+                strings.append(value)
+            else:
+                strings.append(value.encode())
         if len(strings) == 0:
             raise dns.exception.UnexpectedEnd
         return cls(rdclass, rdtype, strings)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         for s in self.strings:
             l = len(s)
             assert l < 256
-            byte = chr(l)
-            file.write(byte)
+            file.write(struct.pack('!B', l))
             file.write(s)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         strings = []
         while rdlen > 0:
-            l = ord(wire[current])
+            l = wire[current]
             current += 1
             rdlen -= 1
             if l > rdlen:
@@ -81,7 +90,5 @@ class TXTBase(dns.rdata.Rdata):
             strings.append(s)
         return cls(rdclass, rdtype, strings)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        return cmp(self.strings, other.strings)
+        return xcmp(self.strings, other.strings)
